var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
  else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { MapToComponentField } from 'vega-slimmer/core';
import { SubStateObserverSlimmer } from '../../../../../helpers/slimmers/sub-state/sub-state-observer-slimmer';
/**
 * Controller for expand row state
 */
export class VegaTableExpandRowStateController extends SubStateObserverSlimmer {
  // eslint-disable-next-line jsdoc/require-jsdoc
  constructor() {
    super({
      parent: 'vega-table',
      subStates: [
        {
          subStateName: 'withMultipleSelection',
          parentStateName: 'rowSelection',
          // eslint-disable-next-line jsdoc/require-jsdoc
          callback: (rowSelection) => {
            if (rowSelection) {
              const { type = 'multiple' } = rowSelection;
              this.withMultipleSelection = type === 'multiple';
            }
            else {
              this.withMultipleSelection = false;
            }
          },
        },
      ],
    });
  }
}
__decorate([
  MapToComponentField()
], VegaTableExpandRowStateController.prototype, "host", void 0);
__decorate([
  MapToComponentField({ writable: true })
], VegaTableExpandRowStateController.prototype, "withMultipleSelection", void 0);
__decorate([
  MapToComponentField()
], VegaTableExpandRowStateController.prototype, "vegaTableExpandRowColSpanController", void 0);
